_crunchy-cli() {
    local i cur prev opts cmd
    COMPREPLY=()
    cur="${COMP_WORDS[COMP_CWORD]}"
    prev="${COMP_WORDS[COMP_CWORD-1]}"
    cmd=""
    opts=""

    for i in ${COMP_WORDS[@]}
    do
        case "${cmd},${i}" in
            ",$1")
                cmd="crunchy__cli"
                ;;
            crunchy__cli,archive)
                cmd="crunchy__cli__archive"
                ;;
            crunchy__cli,download)
                cmd="crunchy__cli__download"
                ;;
            crunchy__cli,help)
                cmd="crunchy__cli__help"
                ;;
            crunchy__cli,login)
                cmd="crunchy__cli__login"
                ;;
            crunchy__cli,search)
                cmd="crunchy__cli__search"
                ;;
            crunchy__cli__help,archive)
                cmd="crunchy__cli__help__archive"
                ;;
            crunchy__cli__help,download)
                cmd="crunchy__cli__help__download"
                ;;
            crunchy__cli__help,help)
                cmd="crunchy__cli__help__help"
                ;;
            crunchy__cli__help,login)
                cmd="crunchy__cli__help__login"
                ;;
            crunchy__cli__help,search)
                cmd="crunchy__cli__help__search"
                ;;
            *)
                ;;
        esac
    done

    case "${cmd}" in
        crunchy__cli)
            opts="-v -q -h -V --verbose --quiet --lang --experimental-fixes --credentials --anonymous --proxy --user-agent --speed-limit --help --version archive download login search help"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 1 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --lang)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --credentials)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --proxy)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --user-agent)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --speed-limit)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        crunchy__cli__archive)
            opts="-a -s -o -r -m -y -t -v -q -h --audio --subtitle --output --output-specials --universal-output --resolution --merge --merge-time-tolerance --merge-sync-tolerance --merge-sync-precision --language-tagging --ffmpeg-preset --ffmpeg-threads --default-subtitle --include-fonts --include-chapters --no-closed-caption --skip-existing --skip-existing-method --skip-specials --yes --threads --verbose --quiet --lang --experimental-fixes --credentials --anonymous --proxy --user-agent --speed-limit --help <URLS>..."
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --audio)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -a)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --subtitle)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -s)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --output)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -o)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --output-specials)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --resolution)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -r)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --merge)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -m)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --merge-time-tolerance)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --merge-sync-tolerance)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --merge-sync-precision)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --language-tagging)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --ffmpeg-preset)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --ffmpeg-threads)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --default-subtitle)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --skip-existing-method)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --threads)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -t)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --lang)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --credentials)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --proxy)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --user-agent)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --speed-limit)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        crunchy__cli__download)
            opts="-a -s -o -r -y -t -v -q -h --audio --subtitle --output --output-specials --universal-output --resolution --language-tagging --ffmpeg-preset --ffmpeg-threads --skip-existing --skip-specials --include-chapters --yes --force-hardsub --threads --verbose --quiet --lang --experimental-fixes --credentials --anonymous --proxy --user-agent --speed-limit --help <URLS>..."
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --audio)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -a)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --subtitle)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -s)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --output)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -o)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --output-specials)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --resolution)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -r)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --language-tagging)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --ffmpeg-preset)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --ffmpeg-threads)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --threads)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -t)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --lang)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --credentials)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --proxy)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --user-agent)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --speed-limit)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        crunchy__cli__help)
            opts="archive download login search help"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        crunchy__cli__help__archive)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        crunchy__cli__help__download)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        crunchy__cli__help__help)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        crunchy__cli__help__login)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        crunchy__cli__help__search)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        crunchy__cli__login)
            opts="-v -q -h --remove --verbose --quiet --lang --experimental-fixes --credentials --anonymous --proxy --user-agent --speed-limit --help"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --lang)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --credentials)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --proxy)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --user-agent)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --speed-limit)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        crunchy__cli__search)
            opts="-o -v -q -h --audio --search-top-results-limit --search-series-limit --search-movie-listing-limit --search-episode-limit --search-music-limit --output --verbose --quiet --lang --experimental-fixes --credentials --anonymous --proxy --user-agent --speed-limit --help <INPUT>"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --audio)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --search-top-results-limit)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --search-series-limit)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --search-movie-listing-limit)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --search-episode-limit)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --search-music-limit)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --output)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -o)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --lang)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --credentials)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --proxy)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --user-agent)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --speed-limit)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
    esac
}

if [[ "${BASH_VERSINFO[0]}" -eq 4 && "${BASH_VERSINFO[1]}" -ge 4 || "${BASH_VERSINFO[0]}" -gt 4 ]]; then
    complete -F _crunchy-cli -o nosort -o bashdefault -o default crunchy-cli
else
    complete -F _crunchy-cli -o bashdefault -o default crunchy-cli
fi
